<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
////////////////////////////////////////////////////////////////////////////////////
session_start();
ob_start('ob_gzhandler');

define('SESSION_NAME', 'session_user');
define('ADMIN_AREA',    defined('ADMIN_ADREA') ? ADMIN_AREA : false);
define('SETUP_DIR',     str_replace('\\','/', ADMIN_AREA ? dirname(getcwd()) : getcwd()).'/');
define('INCLUDE_DIR',   SETUP_DIR.'include/');

// first run ?
if(!file_exists(SETUP_DIR.'config.php') && file_exists(SETUP_DIR.'install.php'))
  redir('install.php');

include_once(SETUP_DIR   . 'config.php');              // User Configuration
include_once(INCLUDE_DIR . 'database.class.php');      // Database Class
include_once(INCLUDE_DIR . 'tpl.class.php');           // Template Class

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//-= User Initialization                                                         =-
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
$tpl       = new Template(SETUP_DIR.'templates');
$db        = new MySQL();
$is_logged = !empty($_SESSION[SESSION_NAME]);
if($is_logged)
{
  $u = $db->get_result("SELECT * FROM tbl0 WHERE `uid`='{$_SESSION[SESSION_NAME]}'", 'users');
  $tpl->assign('user', $u);
  $is_admin = $u['level']==255;
  $tpl->assign('currenttime', date("F d, Y H:i:s", time()));
}
else
  $is_admin  = false;

if(file_exists(SETUP_DIR.'install.php'))
{
  $tpl->assign('main_area', 'install.step5.tpl');
  $tpl->display('install.index.tpl');
  die();
}


// defaults
$settings  = get_settings();
$tpl->assign('settings',  $settings);
$tpl->assign('is_logged', $is_logged);
$tpl->assign('is_admin',  $is_admin);

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//-= General Functions                                                           =-
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
function replace_tags($text, $array)
{
  if(is_array($array))
    foreach($array as $name=>$value)
      $text = str_ireplace("[{$name}]", $value, $text);
  return($text);
}
//---------------------------------------------------------------------------------
function Signup($username, $password, $email, $level=0)
{
  global $db, $settings;
  $sql = "INSERT INTO tbl0 (`username`, `password`, `email`, `level`) " .
         "VALUES ('{$username}', '{$password}', '{$email}', '{$level}')";
  if($db->query($sql,'users'))
  {
    $u    = $db->get_result("SELECT `uid` FROM tbl0 WHERE `username`='{$username}'",'users');
    $code = md5($u['uid'].$username.time());
    $db->query("INSERT INTO tbl0 (`uid`,`code`,`date`) VALUES('{$u['uid']}','{$code}', NOW())",'register');
    SendMail($email, $settings['email_signup_subject'], $settings['email_signup_body']);
  }
}
//---------------------------------------------------------------------------------
function SendMail($email, $subject, $body)
{
  global $settings, $db;
  $sql = "SELECT r.`code`, u.* FROM tbl0 AS u, tbl1 AS r WHERE (u.`email`='{$email}') AND (u.`confirmed`='0') AND (u.`uid`=r.`uid`)";
  if(!$u = $db->get_result($sql,'users,register'))
  { // for some strange reason code not exists, so leave it empty.
    $u = $db->get_result("SELECT * FROM tbl0 WHERE `email`='{$email}'", 'users');
    $u['code'] = '';
  }
  // ? $u['code'] : ''
  $url_confirm = $settings['site_url']."activation.php?code=".$u['code'];
  $a = array(
              'webmaster'        => $settings['site_webmaster_name'].'<'.$settings['site_webmaster_email'].'>',
              'site_url'         => $settings['site_url'],
              'site_name'        => $settings['site_name'],
              'url_confirm'      => $url_confirm,
              'username'         => $u['username'],
              'password'         => $u['password'],
              'email'            => $u['email']
             );
  $headers = replace_tags("From: [webmaster]\r\nReply-To: [webmaster]\r\n", $a);
  $subject = replace_tags($subject, $a);
  $body    = replace_tags($body, $a);
  @mail($email, $subject, $body, $headers);
}

//---------------------------------------------------------------------------------
function get_settings()
{
  global $db;
  $result = array();
  $array  = $db->get_results('SELECT * FROM tbl0 ORDER BY `name`;','settings');
  foreach($array as $item)
    $result[$item['name']] = $item['value'];
  return($result);
}
//---------------------------------------------------------------------------------
function set_setting($name, $value)
{
  global $db;
  $name = strtolower($name);
  if($db->get_total('settings',"`name`='{$name}'") == 0)
    $db->query("INSERT INTO tbl0 (`name`, `value`) VALUES ('{$name}', '{$value}')", 'settings');
  else
    $db->query("UPDATE tbl0 SET `value`='{$value}' WHERE `name`='{$name}'", 'settings');
}
//---------------------------------------------------------------------------------
function update_counters()
{
  global $db;
  set_setting('count_queued', $db->get_total('messages',"`status`='Q'"));
  set_setting('count_posted', $db->get_total('messages',"`status`='P'"));
  set_setting('count_users',  $db->get_total('users'));
  $users = $db->get_results("SELECT `uid` FROM tbl0", 'users');
  foreach($users as $uid)
  {
    $r = $db->get_result("SELECT SUM(`count`) AS total FROM tbl0 WHERE `uid`='{$uid['uid']}'", 'messages');
    if(!is_null($r['total']))
      $db->query("UPDATE tbl0 SET `count`='{$r['total']}' WHERE `uid`='{$uid['uid']}' LIMIT 1", 'users');
  }
}
//---------------------------------------------------------------------------------
function redir($url)
{
  header("Location: $url");
  die();
}
//---------------------------------------------------------------------------------
function get_menu_items($filename, $user_menu, $admin_menu, $insert_before_last = true)
{
  global $tpl, $is_admin;
  $result = array();
  $user  = $tpl->get_menu($filename, $user_menu);
  if($is_admin)
  {
    $admin = $tpl->get_menu($filename, $admin_menu);
    if($insert_before_last)
    {
      $last = null; $c = 0;
      foreach($user as $name => $value)
      {
        if($c == count($user)-1)
        {
          $last[0] = $name;
          $last[1] = $value;
          break;
        }
        else
        {
          $c++;
          $result[$name] = $value;
        }
      }
      foreach($admin as $name => $value)
        $result[$name] = $value;
      $result[$last[0]] = $last[1];
    }
    else
    {
      foreach($admin as $name => $value)
        $result[$name] = $value;
    }
  }
  else
    $result = $user;
  return($result);
}

//---------------------------------------------------------------------------------
function mysql2timestamp($datetime)
{
  $val  = explode(" ", $datetime);
  $date = explode("-", $val[0]);
  $time = explode(":", $val[1]);
  return @mktime($time[0], $time[1], $time[2], $date[1], $date[2], $date[0]);
}

//---------------------------------------------------------------------------------
function get_time_limit($base,&$date1, &$date2)
{
  $t = explode(' ', $base);
  $d = $t[0];
  $t = explode(':', $t[1]);
  $t = intval($t[0]) < 12 ? '0'.$t[0] : $t[0];
  $date1 = "{$d} {$t}:00:00";
  $date2 = "{$d} {$t}:59:00";
}

//---------------------------------------------------------------------------------
function password2str($password)
{
  return(str_repeat("*",strlen($password)));
}

//---------------------------------------------------------------------------------
function types2array()
{
  global $tpl;
  $types = $tpl->get_section('messages.conf','schedule_options');
  $result = array();
  $result['N'] = $types['noreoccurance'];
  $result['D'] = $types['daily'];
  $result['W'] = $types['weekly'];
  $result['M'] = $types['monthly'];
  $result['Y'] = $types['yearly'];
  return($result);
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//-= POST/GET protection                                                         =-
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
function Protect(&$_Array)
{
  foreach($_Array as $key => $value)
    if(is_array($_Array[$key]))
    {
      $tmpArr = $_Array[$key];
      foreach ($tmpArr as $tmpKey => $tmpValue)
        $tmpArr[$tmpKey] = trim(addslashes($tmpValue));
      $_POST[$key] = $tmpArr;
    }
    else
      $_Array[$key] = trim(addslashes($value));
}

// Global Protection
if(!get_magic_quotes_gpc())
{
  if(isset($_POST))
    Protect($_POST);
  if(isset($_GET))
    Protect($_GET);
}
?>