<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.  All Rights Reserved.                                 //
// MySQL Database Class                                                           //
// Version 1.0 Start (14/Jun/2009)                                                //
////////////////////////////////////////////////////////////////////////////////////

define('AS_OBJECT',       'OBJECT',      true);
define('AS_ARRAY_ASSOC',  'ARRAY_ASSOC', true);
define('AS_ARRAY',        'ARRAY',       true);

class MySQL
{
  var $_dblink;

  // private functions
  function _print_error($str = '', $die = true)
  {
    $str = !empty($str) ? $str : mysql_error();
    $str = "MySQL Error : $str\r\n";
    if($die)
      die($str);
    else
      echo $str;
  }

  function _make_sql($sql, $tables, $addcomma=true)
  {
    if(!is_array($tables))
      $tables = explode(',', $tables);
    for($i=0; $i<count($tables); $i++)
      $sql = str_replace("tbl{$i}", '`'.DB_PREFIX.$tables[$i].'`', $sql);
    if($addcomma && substr($sql,strlen($sql)-1,1) != ';')
      $sql .= ';';
    return($sql);
  }

   function MySQL()
  {
    $params = array('DB_SERVER', 'DB_USERNAME', 'DB_PASSWORD', 'DB_DATABASE', 'DB_PREFIX');
    foreach($params as $param)
      if(!defined($param))
        $this->_print_error("{$param} is not defined!");

    if(!$this->_dblink = @mysql_connect(DB_SERVER, DB_USERNAME, DB_PASSWORD))
      $this->_print_error();

    if(!$db_selected = @mysql_select_db(DB_DATABASE, $this->_dblink))
      $this->_print_error();
  }

  function get_sql($sql, $tables, $addcomma = false)
  {
    return($this->_make_sql($sql, $tables, $addcomma));
  }

  // public functions
  function query($sql, $tables)
  {
    $sql = $this->_make_sql($sql, $tables);
    if(!$result = @mysql_query($sql, $this->_dblink))
      $this->_print_error();
    return($result);
  }

  function get_results($sql, $tables, $type=AS_ARRAY_ASSOC)
  {
    $result = array();
    if($q = $this->query($sql, $tables))
    {
      if($type==AS_OBJECT)
        while($r=@mysql_fetch_object($q))
          $result[] = $r;
      elseif($type==AS_ARRAY_ASSOC)
        while($r=@mysql_fetch_assoc($q))
          $result[] = $r;
      else
        while($r=@mysql_fetch_array($q))
          $result[] = $r;
    }
    return($result);
  }

  function get_result($sql, $tables, $type=AS_ARRAY_ASSOC)
  {
    $result = array();
    if($q = $this->query($sql, $tables))
    {
      if($type==AS_OBJECT)
      {
        if($r=@mysql_fetch_object($q))
          $result = $r;
      }
      elseif($type==AS_ARRAY_ASSOC)
      {
        if($r=@mysql_fetch_assoc($q))
          $result = $r;
      }
      else
      {
        if($r=@mysql_fetch_array($q))
          $result = $r;
      }
    }
    return($result);
  }

  function get_total($tables, $where = '')
  {
    $tbl  = array();
    $from = '';
    if(!is_array($tables))
      $tables = explode(',', $tables);

    foreach($tables as $key => $table)
    {
      $idx = is_numeric($key) ? "tbl{$key}" : $key;
      $tbl[$idx] = $table;
      $from .= "$idx,";
    }

    if(substr($from, strlen($from)-1,1) == ',')
      $from = substr($from,0,strlen($from)-1);

    $sql = "SELECT COUNT(*) AS `total` FROM {$from} ".(!empty($where) ? " WHERE $where" : '');
    $result = $this->get_result($sql, $tables);
    return($result['total']);
  }

  function affected_rows() {
    return(mysql_affected_rows());
  }

  function insert_or_update_array($array, $table, $where, $where_update)
  {
    $result = false;
    if(is_array($array))
    {
      if($this->get_total($table, $where))
      {
        $v = '';
        foreach($array as $name=>$value)
          $v .= "`{$name}`='{$value}',";
        $v = substr($v,0,strlen($n)-1);
        $sql = "UPDATE tbl0 SET {$v} WHERE {$where_update} LIMIT 1;";
      }
      else
      {
        $n = $v = '';
        foreach($array as $name=>$value)
        {
          $n .= "`{$name}`,";
          $v .= "'{$value}',";
        }
        $n = substr($n,0,strlen($n)-1);
        $v = substr($v,0,strlen($v)-1);
        $sql = "INSERT INTO tbl0 ({$n}) VALUES({$v});";
      }
      $result = $this->query($sql, $table);
    }
    else
      $this->_print_error("insert_array(\$array) is not an array");
    return($result);
  }
}
?>